import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class MyArrayListTest {

    @Test
    public void addIntTest() {
        //given
        Integer [] testIntArray = {1, 2, 3, 4, 5};
        MyArrayList<Integer> myarrayList = new MyArrayList<Integer>(testIntArray);
        int elementToAdd = 6;
        int expected = 6;
        //when
        myarrayList.add(elementToAdd);
        int actual = myarrayList.size();
        //then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getTest() {
        //given
        String [] testStringArray = {"I", "went", "to", "the", "bookstore"};
        MyArrayList<String> myArrayList = new MyArrayList<>(testStringArray);
        String expected = "to";
        //when
        String actual = myArrayList.get(2);
        //then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void setTest() {
        //given
        Integer [] testIntegerArray = {1, 2, 3, 4, 5, 10};
        MyArrayList<Integer> myArrayList = new MyArrayList<>(testIntegerArray);
        Integer [] expected = {1, 2, 3, 4, 5, 6};
        //when
        Integer [] actual = myArrayList.set(5, 6);
        //then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void clearStringTest() {
        //given
        String [] testStringArr = {"I", "am", "making", "some", "progress"};
        MyArrayList<String> myArrayList = new MyArrayList<>(testStringArr);
        //when
        myArrayList.clear();
        //then
        Assert.assertNull(testStringArr[1]);
    }


    @Test
    public void clearIntTest() {
        //given
        Integer [] testIntegerArr = {3, 5, 6, 7, 1};
        MyArrayList<Integer> myArrayList = new MyArrayList<>(testIntegerArr);
        //when
        myArrayList.clear();
        //then
        Assert.assertNull(testIntegerArr[1]);
    }

    @Test
    public void isEmptyIntegerTest() {
        //given
        Integer [] testIntegerArray = {1, 3, 4};
        MyArrayList<Integer> myArrayList = new MyArrayList<>(testIntegerArray);
        //when
        boolean actual = myArrayList.isEmpty();
        //then
        Assert.assertFalse(actual);
    }

    @Test
    public void isEmptyBooleanTest() {
        //given
        Boolean [] testBoolsArray = {true, false, false, true};
        MyArrayList<Boolean> myArrayList = new MyArrayList<>(testBoolsArray);
        //when
        boolean actual = myArrayList.isEmpty();
        //then
        Assert.assertFalse(actual);
    }

    @Test
    public void isActuallyEmptyTest() {
        //given
        Integer [] testEmptyArray = {};
        MyArrayList<Integer> myArrayList = new MyArrayList<>(testEmptyArray);
        //when
        boolean actual = myArrayList.isEmpty();
        //then
        Assert.assertTrue(actual);
    }


    @Test
    public void containsTrueTest() {
        //given
        Object [] testObjArray = {5, "Pushing", "on", "through", "them", "labs", "BOII", 10};
        MyArrayList<Object> myArrayList = new MyArrayList<>(testObjArray);
        //when
        boolean actual = myArrayList.contains("through");
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void containsFalseTest() {
        //given
        Object [] testObjArray = {5, "Pushing", "on", "through", "them", "labs", "BOII", 10};
        MyArrayList<Object> myArrayList = new MyArrayList<>(testObjArray);
        //when
        boolean actual = myArrayList.contains(true);
        //then
        Assert.assertFalse(actual);
    }


    @Test
    public void addOverrideTest() {
        //given
        Integer [] testOverrideAddInts = {1, 3, 4, 5};
        MyArrayList<Integer> myArrayList = new MyArrayList<>(testOverrideAddInts);
        //when
        myArrayList.add(1, 2);
        int actual = myArrayList.get(1);
        //then
        Assert.assertEquals(2, actual);
    }
}